"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
var minimist_1 = __importDefault(require("minimist"));
var writeRouteFile_1 = __importDefault(require("aspida/dist/writeRouteFile"));
var watchInputDir_1 = __importDefault(require("aspida/dist/watchInputDir"));
var buildServerFile_1 = __importDefault(require("./buildServerFile"));
var cleanStaleRoutes_1 = __importDefault(require("./cleanStaleRoutes"));
var cleanAllStaleRoutes_1 = __importDefault(require("./cleanAllStaleRoutes"));
var run = function (args) {
    var argv = (0, minimist_1.default)(args, {
        string: ['version', 'watch', 'project'],
        alias: { v: 'version', w: 'watch', p: 'project' }
    });
    var dir = '.';
    if (argv.version !== undefined) {
        console.log("v".concat(require('../package.json').version));
    }
    else if (argv.watch !== undefined) {
        (0, cleanAllStaleRoutes_1.default)(dir);
        (0, writeRouteFile_1.default)((0, buildServerFile_1.default)(dir, argv.project));
        (0, watchInputDir_1.default)(dir, function (event, file) {
            (0, cleanStaleRoutes_1.default)(dir, event, file);
            (0, writeRouteFile_1.default)((0, buildServerFile_1.default)(dir, argv.project));
        });
    }
    else {
        (0, cleanAllStaleRoutes_1.default)(dir);
        (0, writeRouteFile_1.default)((0, buildServerFile_1.default)(dir, argv.project));
    }
};
exports.run = run;
//# sourceMappingURL=index.js.map